/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseComboBoxLike } from "./BaseComboBoxLike";
import { DropdownPlacement_$type } from "./DropdownPlacement";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { WCNativeHelper } from "./WCNativeHelper";
import { DropdownPositionStrategy_$type } from "./DropdownPositionStrategy";
import { DropdownScrollStrategy_$type } from "./DropdownScrollStrategy";
import { DropdownItem } from "./DropdownItem";
import { DropdownGroup } from "./DropdownGroup";
import { SizableComponentSize_$type } from "./SizableComponentSize";
import { VoidEventArgs } from "./VoidEventArgs";
import { DropdownItemComponentEventArgs } from "./DropdownItemComponentEventArgs";
/**
 * @hidden
 */
export let Dropdown = /*@__PURE__*/ (() => {
    class Dropdown extends BaseComboBoxLike {
        constructor() {
            super(...arguments);
            this.opening = null;
            this.opened = null;
            this.closing = null;
            this.closed = null;
            this.change = null;
        }
        showTarget(target_) {
            this.nativeElement.show(target_);
        }
        toggleTarget(target_) {
            this.nativeElement.toggle(target_);
        }
        o(a) {
            return (this.nativeElement.navigateTo(a));
        }
        p(a) {
            return (this.nativeElement.select(a));
        }
        get s() {
            let ret_ = this.b.n("placement");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(DropdownPlacement_$type, EnumUtil.getEnumValue(DropdownPlacement_$type, this.b.f(DropdownPlacement_$type, ret_)));
            return EnumUtil.getEnumValue(DropdownPlacement_$type, ret_);
        }
        set s(a) {
            let value_ = enumGetBox(DropdownPlacement_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b.v("placement", value_);
        }
        get t() {
            let ret_ = this.b.n("positionStrategy");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(DropdownPositionStrategy_$type, EnumUtil.getEnumValue(DropdownPositionStrategy_$type, this.b.f(DropdownPositionStrategy_$type, ret_)));
            return EnumUtil.getEnumValue(DropdownPositionStrategy_$type, ret_);
        }
        set t(a) {
            let value_ = enumGetBox(DropdownPositionStrategy_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b.v("positionStrategy", value_);
        }
        get u() {
            let ret_ = this.b.n("scrollStrategy");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(DropdownScrollStrategy_$type, EnumUtil.getEnumValue(DropdownScrollStrategy_$type, this.b.f(DropdownScrollStrategy_$type, ret_)));
            return EnumUtil.getEnumValue(DropdownScrollStrategy_$type, ret_);
        }
        set u(a) {
            let value_ = enumGetBox(DropdownScrollStrategy_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b.v("scrollStrategy", value_);
        }
        get aa() {
            let ret_ = this.b.n("flip");
            return ret_;
        }
        set aa(a) {
            let value_ = a;
            this.b.v("flip", value_);
        }
        get ac() {
            let ret_ = this.b.n("distance");
            return ret_;
        }
        set ac(a) {
            let value_ = a;
            this.b.v("distance", value_);
        }
        get ab() {
            let ret_ = this.b.n("sameWidth");
            return ret_;
        }
        set ab(a) {
            let value_ = a;
            this.b.v("sameWidth", value_);
        }
        get n() {
            let ret_ = this.b.m("items", (a) => new DropdownItem());
            return ret_;
        }
        get m() {
            let ret_ = this.b.m("groups", (a) => new DropdownGroup());
            return ret_;
        }
        get q() {
            let ret_ = this.b.m("selectedItem", (a) => new DropdownItem());
            return ret_;
        }
        get v() {
            let ret_ = this.b.n("size");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(SizableComponentSize_$type, EnumUtil.getEnumValue(SizableComponentSize_$type, this.b.f(SizableComponentSize_$type, ret_)));
            return EnumUtil.getEnumValue(SizableComponentSize_$type, ret_);
        }
        set v(a) {
            let value_ = enumGetBox(SizableComponentSize_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.b.v("size", value_);
        }
        openingChanged() {
            if (this.opening != null) {
                this.b.r("opening", (a) => this.opening(this, VoidEventArgs.b(a)));
            }
            else {
                this.b.u("opening");
            }
        }
        openedChanged() {
            if (this.opened != null) {
                this.b.r("opened", (a) => this.opened(this, VoidEventArgs.b(a)));
            }
            else {
                this.b.u("opened");
            }
        }
        closingChanged() {
            if (this.closing != null) {
                this.b.r("closing", (a) => this.closing(this, VoidEventArgs.b(a)));
            }
            else {
                this.b.u("closing");
            }
        }
        closedChanged() {
            if (this.closed != null) {
                this.b.r("closed", (a) => this.closed(this, VoidEventArgs.b(a)));
            }
            else {
                this.b.u("closed");
            }
        }
        changeChanged() {
            if (this.change != null) {
                this.b.r("change", (a) => this.change(this, DropdownItemComponentEventArgs.b(a)));
            }
            else {
                this.b.u("change");
            }
        }
        ah() {
            this.nativeElement.disconnectedCallback();
        }
        ae() {
            this.nativeElement.clearSelection();
        }
    }
    Dropdown.$t = /*@__PURE__*/ markType(Dropdown, 'Dropdown', BaseComboBoxLike.$);
    return Dropdown;
})();
